/*
	Worms Like deaths
	by $$$Superboy$$$
	
	Description:
	
		There are a lot of people that know the worms games.
		This plugin tryes to reinact that style of death, by making an explosion and 
		putting a grave like the dead worms do.
	
	
	Cvars:
	
		amx_wormsdeaths_on 1					Turns worms deaths on/off
		amx_wormsdeath_sound 1					Turns the sound on/off
	
	Changelog:
		v1.0: Initial release
		
	Credits:
		Wrecked: Helping to solve annoying tag mismatch and other stuff
		Anakin_cstrike: the grave models
	To do:
		I have no idea
		
*/
#include <amxmodx>
#include <hamsandwich>
#include <engine>

#define VERSION "1.0"

#define IsPlayer(%1)    (1<=%1<=g_maxplayers)

new cvar_on, cvar_sound

new xplodespr, smokespr
new hahasnd 

new g_maxplayers

public plugin_init()
{
	register_plugin("Worms like Deaths", VERSION, "Drekes")
	
	RegisterHam(Ham_Killed, "player", "Event_Ham_Killed_Pre", 0)
	
	cvar_on = register_cvar("amx_wormsdeath_on", "1")
	cvar_sound = register_cvar("amx_wormsdeath_sound", "1")
	
	g_maxplayers = get_maxplayers()
}

public plugin_precache()
{
	precache_model("models/wormsdeaths/t_grave.mdl")
	precache_model("models/wormsdeaths/ct_grave.mdl")
	
	xplodespr = precache_model("sprites/wormsdeaths/explosion.spr")
	smokespr = precache_model("sprites/wormsdeaths/smoke.spr")
	
	hahasnd = precache_sound("misc/grave_sound2.wav")
}

public Event_Ham_Killed_Pre(victim, attacker, shouldgib)
{	
	if(get_pcvar_num(cvar_on))
	{
		if(IsPlayer(victim) && is_user_connected(victim))
		{
			new Float: origin[3]
			entity_get_vector(victim, EV_VEC_origin, origin)
			
			make_smoke(origin)
			make_explosion(origin)
			set_grave(victim, origin)

			
			client_cmd(attacker, "spk ^"sound/%s^"", hahasnd)
			client_cmd(victim, "spk ^"sound/%s^"", hahasnd)
		}
	}
}

public set_grave(id, Float: origin[3])
{
	new team = get_user_team(id)
	new Ent = create_entity("info_target")   
	
	if(!Ent)      
		return         

	entity_set_string(Ent, EV_SZ_classname, "grave")
	entity_set_int(Ent, EV_INT_solid, 2)
	
	if(team == 1)
		entity_set_model(Ent, "models/wormsdeaths/t_grave.mdl")
	
	else
		entity_set_model(Ent, "models/wormsdeaths/ct_grave.mdl")
	
	new Float: maxs[3] = {16.0, 16.0, 36.0}
	new Float: mins[3] = {-16.0, -16.0, -36.0}
	entity_set_size(Ent, mins, maxs)
	
	origin[2] -= 35.0
	entity_set_origin(Ent, origin)
	
	set_task(10.0, "remove_grave", Ent)
}

public remove_grave(Ent)
{
	if(is_valid_ent(Ent))
		remove_entity(Ent)
}

make_explosion(Float: origin[3])
{	
	new IntOrigin[3]
	FVecIVec(origin, IntOrigin)
	
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY, IntOrigin)
	write_byte(TE_EXPLOSION)
	write_coord(IntOrigin[0])
	write_coord(IntOrigin[1])
	write_coord(IntOrigin[2])
	write_short(xplodespr)
	write_byte(10)
	write_byte(2)
	write_byte(TE_EXPLFLAG_NOSOUND)	
	message_end()
	
	if(get_pcvar_num(cvar_sound))
		emit_sound(0,CHAN_ITEM, "misc/grave_sound2.wav" , 1.0, ATTN_NORM, 0, PITCH_NORM);
}

make_smoke(Float: origin[3])
{
	new IntOrigin[3]
	FVecIVec(origin, IntOrigin)
	
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY, IntOrigin)
	write_byte(TE_EXPLOSION)
	write_coord(IntOrigin[0])
	write_coord(IntOrigin[1])
	write_coord(IntOrigin[2])
	write_short(smokespr)
	write_byte(50)
	write_byte(2)
	write_byte(TE_EXPLFLAG_NOSOUND)	
	message_end()
}